var should = require('should');
var run = require('../proxy/server');
var fixtures = require('./fixtures.json');
var ClientV1 = require('../proxy-client/v1');
var path = require('path');
var rp = require('request-promise');
var support = require('./support');
var session;
var credentails = []; // [username, password, proxy]

const TRY_TO_CREATE_ACCOUNT = false

run({
    port: fixtures["server.port"],
    socketPort: fixtures["server.socket-port"],
    host: fixtures["server.host"],
    databaseDir: './tests/tmp/databases',
    cookiesDir: './tests/tmp/cookies',
    // proxy: 'http://127.0.0.1:8888',
    // interfaces: '10.0.0.2'
    suppressLog: true
})


describe('server', function() {
    it("should start", function (done) {
        var url = "http://" + fixtures["server.host"] + ":" + fixtures["server.port"] + "/v1"
        return rp.get(url).then(function (json) {
            json = JSON.parse(json);
            json.should.have.property('node', true)
            json.should.have.property('sessions')
            json.sessions.should.be.a.Number();
            done()
        })
    })
});


function credentilasBeforeHook(done) {
    // Wait one hour
    this.timeout(60 * 60 * 1000);
    support.credentials()
        .then(function (auth) {
            credentails = auth;
            done();
        });
}

describe("Credentials", function() {

    before(credentilasBeforeHook);


    it("should have credentials", function () {
        credentails.length.should.be.equal(3);
        credentails[0].should.be.String()
        credentails[1].should.be.String()
    });

})


describe("proxy", function () {

    before(credentilasBeforeHook);

    console.log(credentails)
     if(TRY_TO_CREATE_ACCOUNT)
         require('./proxy/v1/account')  
    require('./proxy/v1/qe')  
     require('./proxy/v1/addresses')  
     require('./proxy/v1/request')  
     require('./proxy/v1/discover')  
});





var proxyClientWithSession = function () {    
    require('./proxy-client/v1/registration')
    require('./proxy-client/v1/account')
    require('./proxy-client/v1/upload')
    require('./proxy-client/v1/media')
    require('./proxy-client/v1/thread')
    require('./proxy-client/v1/comment')
    require('./proxy-client/v1/like')
    require('./proxy-client/v1/relationship')
    require('./proxy-client/v1/hashtag')
    require('./proxy-client/v1/location')
    require('./proxy-client/v1/log')
}

describe("proxy-client", function () {
    require('./proxy-client/v1/server')  
    require('./proxy-client/v1/session')(proxyClientWithSession) 
})
